package wordcheck;

import java.util.stream.Stream;
import static java.util.stream.Collectors.joining;

public class WordProcessor {
  private final SpellChecker spellChecker;

  public WordProcessor(SpellChecker aSpellChecker) {
    spellChecker = aSpellChecker;
  }
  private String processWord(String word) {
    try {
      return spellChecker.isSpellingCorrect(word) ? word : "_%s_".formatted(word);
    } catch(RuntimeException ex) {
      return "~%s~".formatted(word);
    }
  }

  public String processText(String text) {
    return Stream.of(text.split(" "))
      .map(this::processWord)
      .collect(joining(" "));
  }
}
