package wordcheck;

import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;

public class AgileDeveloperSpellCheck implements SpellChecker {
  @Override
  public boolean isSpellingCorrect(String word) {
    try {
      var url = System.getProperty("SPELLCHECKER_URL");

      var request = HttpRequest.newBuilder()
        .uri(new URI("%s/spellcheck?check=%s".formatted(url, word)))
        .GET()
        .build();

      try (var httpClient = HttpClient.newHttpClient()) {
        var response = httpClient.send(request, HttpResponse.BodyHandlers.ofString());

        var body = response.body();

        return body.equals("true");
      }
    } catch (URISyntaxException | IOException | InterruptedException  ex) {
      throw new RuntimeException(ex);
    }
  }
}
